/[gentoo-x86]/eclass/webapp.eclass
Gentoo

Diff of /eclass/webapp.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.50 Revision 1.70
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.50 2008/02/22 10:03:55 hollow Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.70 2011/12/27 17:55:12 fauli Exp $
4# 4
5# @ECLASS: webapp.eclass 5# @ECLASS: webapp.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# web-apps@gentoo.org 7# web-apps@gentoo.org
8# @BLURB: functions for installing applications to run under a web server 8# @BLURB: functions for installing applications to run under a web server
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The webapp eclass contains functions to handle web applications with 10# The webapp eclass contains functions to handle web applications with
11# webapp-config. Part of the implementation of GLEP #11 11# webapp-config. Part of the implementation of GLEP #11
12 12
13# @ECLASS-VARIABLE: WEBAPP_DEPEND
14# @DESCRIPTION:
15# An ebuild should use WEBAPP_DEPEND if a custom DEPEND needs to be built, most
16# notably in combination with WEBAPP_OPTIONAL.
17WEBAPP_DEPEND=">=app-admin/webapp-config-1.50.15"
18
19# @ECLASS-VARIABLE: WEBAPP_NO_AUTO_INSTALL
20# @DESCRIPTION:
21# An ebuild sets this to `yes' if an automatic installation and/or upgrade is
22# not possible. The ebuild should overwrite pkg_postinst() and explain the
23# reason for this BEFORE calling webapp_pkg_postinst().
24
25# @ECLASS-VARIABLE: WEBAPP_OPTIONAL
26# @DESCRIPTION:
27# An ebuild sets this to `yes' to make webapp support optional, in which case
28# you also need to take care of USE-flags and dependencies.
29
30if [[ "${WEBAPP_OPTIONAL}" != "yes" ]]; then
31 [[ "${WEBAPP_NO_AUTO_INSTALL}" == "yes" ]] || IUSE="vhosts"
13SLOT="${PVR}" 32 SLOT="${PVR}"
14IUSE="vhosts" 33 DEPEND="${WEBAPP_DEPEND}"
15DEPEND=">=app-admin/webapp-config-1.50.15"
16RDEPEND="${DEPEND}" 34 RDEPEND="${DEPEND}"
35fi
17 36
18EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm 37EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm
19 38
20INSTALL_DIR="/${PN}" 39INSTALL_DIR="/${PN}"
21IS_UPGRADE=0 40IS_UPGRADE=0
22IS_REPLACE=0 41IS_REPLACE=0
23 42
24INSTALL_CHECK_FILE="installed_by_webapp_eclass" 43INSTALL_CHECK_FILE="installed_by_webapp_eclass"
44SETUP_CHECK_FILE="setup_by_webapp_eclass"
25 45
26ETC_CONFIG="${ROOT}/etc/vhosts/webapp-config" 46ETC_CONFIG="${ROOT}etc/vhosts/webapp-config"
27WEBAPP_CONFIG="${ROOT}/usr/sbin/webapp-config" 47WEBAPP_CONFIG="${ROOT}usr/sbin/webapp-config"
28WEBAPP_CLEANER="${ROOT}/usr/sbin/webapp-cleaner" 48WEBAPP_CLEANER="${ROOT}usr/sbin/webapp-cleaner"
29 49
30# ============================================================================== 50# ==============================================================================
31# INTERNAL FUNCTIONS 51# INTERNAL FUNCTIONS
32# ============================================================================== 52# ==============================================================================
33 53
34# Load the config file /etc/vhosts/webapp-config 54# Load the config file /etc/vhosts/webapp-config
35# Supports both the old bash version, and the new python version 55# Supports both the old bash version, and the new python version
36webapp_read_config() { 56webapp_read_config() {
57 debug-print-function $FUNCNAME $*
58
37 if has_version '>=app-admin/webapp-config-1.50'; then 59 if has_version '>=app-admin/webapp-config-1.50'; then
38 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!" 60 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!"
39 eval ${ENVVAR} 61 eval ${ENVVAR}
40 else 62 elif [[ "${WEBAPP_OPTIONAL}" != "yes" ]]; then
63 # ETC_CONFIG might not be available
64 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
65 elif [[ -f "${ETC_CONFIG}" ]]; then
66 # WEBAPP_OPTIONAL is set to yes
67 # and this must run only if ETC_CONFIG actually exists
41 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}" 68 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
42 fi 69 fi
43} 70}
44 71
45# Check whether a specified file exists in the given directory (`.' by default) 72# Check whether a specified file exists in the given directory (`.' by default)
46webapp_checkfileexists() { 73webapp_checkfileexists() {
47 local my_prefix 74 debug-print-function $FUNCNAME $*
48 75
49 [ -n "${2}" ] && my_prefix="${2}/" || my_prefix= 76 local my_prefix=${2:+${2}/}
50 77
51 if [ ! -e "${my_prefix}${1}" ]; then 78 if [[ ! -e "${my_prefix}${1}" ]]; then
52 msg="ebuild fault: file '${1}' not found" 79 msg="ebuild fault: file '${1}' not found"
53 eerror "$msg" 80 eerror "$msg"
54 eerror "Please report this as a bug at http://bugs.gentoo.org/" 81 eerror "Please report this as a bug at http://bugs.gentoo.org/"
55 die "$msg" 82 die "$msg"
56 fi 83 fi
57} 84}
58 85
59webapp_check_installedat() { 86webapp_check_installedat() {
87 debug-print-function $FUNCNAME $*
60 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null 88 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null
61} 89}
62 90
63webapp_strip_appdir() { 91webapp_strip_appdir() {
64 local my_stripped="${1}" 92 debug-print-function $FUNCNAME $*
65 echo "${1}" | sed -e "s|${MY_APPDIR}/||g;" 93 echo "${1#${MY_APPDIR}/}"
66} 94}
67 95
68webapp_strip_d() { 96webapp_strip_d() {
69 echo "${1}" | sed -e "s|${D}||g;" 97 debug-print-function $FUNCNAME $*
98 echo "${1#${D}}"
70} 99}
71 100
72webapp_strip_cwd() { 101webapp_strip_cwd() {
73 local my_stripped="${1}" 102 debug-print-function $FUNCNAME $*
74 echo "${1}" | sed -e 's|/./|/|g;' 103 echo "${1/#.\///}"
75} 104}
76 105
77webapp_getinstalltype() { 106webapp_getinstalltype() {
78 # or are we upgrading? 107 debug-print-function $FUNCNAME $*
79 108
80 if ! use vhosts ; then 109 if ! has vhosts ${IUSE} || use vhosts; then
81 # we only run webapp-config if vhosts USE flag is not set 110 return
111 fi
82 112
83 local my_output 113 local my_output
84
85 my_output="$(webapp_check_installedat)" 114 my_output="$(webapp_check_installedat)"
86 115
87 if [ "${?}" = "0" ] ; then 116 if [[ $? -eq 0 ]]; then
88 # something is already installed there 117 # something is already installed there
89 #
90 # make sure it isn't the same version 118 # make sure it isn't the same version
91 119
92 local my_pn="$(echo ${my_output} | awk '{ print $1 }')" 120 local my_pn="$(echo ${my_output} | awk '{ print $1 }')"
93 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')" 121 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')"
94 122
95 REMOVE_PKG="${my_pn}-${my_pvr}" 123 REMOVE_PKG="${my_pn}-${my_pvr}"
96 124
97 if [ "${my_pn}" == "${PN}" ]; then 125 if [[ "${my_pn}" == "${PN}" ]]; then
98 if [ "${my_pvr}" != "${PVR}" ]; then 126 if [[ "${my_pvr}" != "${PVR}" ]]; then
99 elog "This is an upgrade" 127 elog "This is an upgrade"
100 IS_UPGRADE=1 128 IS_UPGRADE=1
101 else 129 # for binpkgs, reset status, var declared in global scope
102 elog "This is a re-installation"
103 IS_REPLACE=1 130 IS_REPLACE=0
104 fi
105 else 131 else
106 elog "${my_output} is installed there" 132 elog "This is a re-installation"
133 IS_REPLACE=1
134 # for binpkgs, reset status, var declared in global scope
135 IS_UPGRADE=0
107 fi 136 fi
108 else 137 else
109 elog "This is an installation" 138 elog "${my_output} is installed there"
110 fi 139 fi
140 else
141 # for binpkgs, reset status, var declared in global scope
142 IS_REPLACE=0
143 IS_UPGRADE=0
144 elog "This is an installation"
111 fi 145 fi
112} 146}
113 147
114# ============================================================================== 148# ==============================================================================
115# PUBLIC FUNCTIONS 149# PUBLIC FUNCTIONS
116# ============================================================================== 150# ==============================================================================
117 151
152# @FUNCTION: need_httpd
153# @DESCRIPTION:
154# Call this function AFTER your ebuilds DEPEND line if any of the available
155# webservers are able to run this application.
156need_httpd() {
157 DEPEND="${DEPEND}
158 || ( virtual/httpd-basic virtual/httpd-cgi virtual/httpd-fastcgi )"
159}
160
161# @FUNCTION: need_httpd_cgi
162# @DESCRIPTION:
163# Call this function AFTER your ebuilds DEPEND line if any of the available
164# CGI-capable webservers are able to run this application.
165need_httpd_cgi() {
166 DEPEND="${DEPEND}
167 || ( virtual/httpd-cgi virtual/httpd-fastcgi )"
168}
169
170# @FUNCTION: need_httpd_fastcgi
171# @DESCRIPTION:
172# Call this function AFTER your ebuilds DEPEND line if any of the available
173# FastCGI-capabale webservers are able to run this application.
174need_httpd_fastcgi() {
175 DEPEND="${DEPEND}
176 virtual/httpd-fastcgi"
177}
178
118# @FUNCTION: webapp_configfile 179# @FUNCTION: webapp_configfile
119# @USAGE: <file> [more files ...] 180# @USAGE: <file> [more files ...]
120# @DESCRIPTION: 181# @DESCRIPTION:
121# Mark a file config-protected for a web-based application. 182# Mark a file config-protected for a web-based application.
122webapp_configfile() { 183webapp_configfile() {
184 debug-print-function $FUNCNAME $*
185
123 local m="" 186 local m
124 for m in "$@" ; do 187 for m in "$@"; do
125 webapp_checkfileexists "${m}" "${D}" 188 webapp_checkfileexists "${m}" "${D}"
126 189
127 local MY_FILE="$(webapp_strip_appdir "${m}")" 190 local my_file="$(webapp_strip_appdir "${m}")"
128 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 191 my_file="$(webapp_strip_cwd "${my_file}")"
129 192
130 elog "(config) ${MY_FILE}" 193 elog "(config) ${my_file}"
131 echo "${MY_FILE}" >> ${D}/${WA_CONFIGLIST} 194 echo "${my_file}" >> ${D}/${WA_CONFIGLIST}
132 done 195 done
133} 196}
134 197
135# @FUNCTION: webapp_hook_script 198# @FUNCTION: webapp_hook_script
136# @USAGE: <file> 199# @USAGE: <file>
137# @DESCRIPTION: 200# @DESCRIPTION:
138# Install a script that will run after a virtual copy is created, and 201# Install a script that will run after a virtual copy is created, and
139# before a virtual copy has been removed. 202# before a virtual copy has been removed.
140webapp_hook_script() { 203webapp_hook_script() {
204 debug-print-function $FUNCNAME $*
205
141 webapp_checkfileexists "${1}" 206 webapp_checkfileexists "${1}"
142 207
143 elog "(hook) ${1}" 208 elog "(hook) ${1}"
144 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/" 209 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/"
145 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" 210 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")"
148# @FUNCTION: webapp_postinst_txt 213# @FUNCTION: webapp_postinst_txt
149# @USAGE: <lang> <file> 214# @USAGE: <lang> <file>
150# @DESCRIPTION: 215# @DESCRIPTION:
151# Install a text file containing post-installation instructions. 216# Install a text file containing post-installation instructions.
152webapp_postinst_txt() { 217webapp_postinst_txt() {
218 debug-print-function $FUNCNAME $*
219
153 webapp_checkfileexists "${2}" 220 webapp_checkfileexists "${2}"
154 221
155 elog "(info) ${2} (lang: ${1})" 222 elog "(info) ${2} (lang: ${1})"
156 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt" 223 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt"
157} 224}
159# @FUNCTION: webapp_postupgrade_txt 226# @FUNCTION: webapp_postupgrade_txt
160# @USAGE: <lang> <file> 227# @USAGE: <lang> <file>
161# @DESCRIPTION: 228# @DESCRIPTION:
162# Install a text file containing post-upgrade instructions. 229# Install a text file containing post-upgrade instructions.
163webapp_postupgrade_txt() { 230webapp_postupgrade_txt() {
231 debug-print-function $FUNCNAME $*
232
164 webapp_checkfileexists "${2}" 233 webapp_checkfileexists "${2}"
165 234
166 elog "(info) ${2} (lang: ${1})" 235 elog "(info) ${2} (lang: ${1})"
167 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt" 236 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt"
237}
238
239# helper for webapp_serverowned()
240_webapp_serverowned() {
241 debug-print-function $FUNCNAME $*
242
243 webapp_checkfileexists "${1}" "${D}"
244 local my_file="$(webapp_strip_appdir "${1}")"
245 my_file="$(webapp_strip_cwd "${my_file}")"
246
247 elog "(server owned) ${my_file}"
248 echo "${my_file}" >> "${D}/${WA_SOLIST}"
168} 249}
169 250
170# @FUNCTION: webapp_serverowned 251# @FUNCTION: webapp_serverowned
171# @USAGE: [-R] <file> [more files ...] 252# @USAGE: [-R] <file> [more files ...]
172# @DESCRIPTION: 253# @DESCRIPTION:
173# Identify a file which must be owned by the webserver's user:group settings. 254# Identify a file which must be owned by the webserver's user:group settings.
174# The ownership of the file is NOT set until the application is installed using 255# The ownership of the file is NOT set until the application is installed using
175# the webapp-config tool. If -R is given directories are handled recursively. 256# the webapp-config tool. If -R is given directories are handled recursively.
176webapp_serverowned() { 257webapp_serverowned() {
258 debug-print-function $FUNCNAME $*
259
177 local a="" 260 local a m
178 local m=""
179 if [ "${1}" = "-R" ]; then 261 if [[ "${1}" == "-R" ]]; then
180 shift 262 shift
181 for m in "$@" ; do 263 for m in "$@"; do
182 for a in $(find ${D}/${m}); do 264 find "${D}${m}" | while read a; do
183 a=${a/${D}\/\///}
184 webapp_checkfileexists "${a}" "$D"
185 local MY_FILE="$(webapp_strip_appdir "${a}")" 265 a=$(webapp_strip_d "${a}")
186 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")" 266 _webapp_serverowned "${a}"
187
188 elog "(server owned) ${MY_FILE}"
189 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
190 done 267 done
191 done 268 done
192 else 269 else
193 for m in "$@" ; do 270 for m in "$@"; do
194 webapp_checkfileexists "${m}" "$D" 271 _webapp_serverowned "${m}"
195 local MY_FILE="$(webapp_strip_appdir "${m}")"
196 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
197
198 elog "(server owned) ${MY_FILE}"
199 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
200 done 272 done
201 fi 273 fi
202} 274}
203 275
204# @FUNCTION: webapp_server_configfile 276# @FUNCTION: webapp_server_configfile
207# Install a configuration file for the webserver. You need to specify a 279# Install a configuration file for the webserver. You need to specify a
208# webapp-config supported <server>. if no new name is given `basename $2' is 280# webapp-config supported <server>. if no new name is given `basename $2' is
209# used by default. Note: this function will automagically prepend $1 to the 281# used by default. Note: this function will automagically prepend $1 to the
210# front of your config file's name. 282# front of your config file's name.
211webapp_server_configfile() { 283webapp_server_configfile() {
284 debug-print-function $FUNCNAME $*
285
212 webapp_checkfileexists "${2}" 286 webapp_checkfileexists "${2}"
213 287
214 # sort out what the name will be of the config file 288 # WARNING:
215
216 local my_file
217
218 if [ -z "${3}" ]; then
219 my_file="${1}-$(basename "${2}")"
220 else
221 my_file="${1}-${3}"
222 fi
223
224 # warning:
225 # 289 #
226 # do NOT change the naming convention used here without changing all 290 # do NOT change the naming convention used here without changing all
227 # the other scripts that also rely upon these names 291 # the other scripts that also rely upon these names
292
293 local my_file="${1}-${3:-$(basename "${2}")}"
228 294
229 elog "(${1}) config file '${my_file}'" 295 elog "(${1}) config file '${my_file}'"
230 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}" 296 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}"
231} 297}
232 298
236# Install a SQL script that creates/upgrades a database schema for the web 302# Install a SQL script that creates/upgrades a database schema for the web
237# application. Currently supported database engines are mysql and postgres. 303# application. Currently supported database engines are mysql and postgres.
238# If a version is given the script should upgrade the database schema from 304# If a version is given the script should upgrade the database schema from
239# the given version to $PVR. 305# the given version to $PVR.
240webapp_sqlscript() { 306webapp_sqlscript() {
307 debug-print-function $FUNCNAME $*
308
241 webapp_checkfileexists "${2}" 309 webapp_checkfileexists "${2}"
242 310
243 # create the directory where this script will go 311 dodir "${MY_SQLSCRIPTSDIR}/${1}"
244 #
245 # scripts for specific database engines go into their own subdirectory
246 # just to keep things readable on the filesystem
247 312
248 if [ ! -d "${D}/${MY_SQLSCRIPTSDIR}/${1}" ]; then 313 # WARNING:
249 mkdir -p "${D}/${MY_SQLSCRIPTSDIR}/${1}" || die "unable to create directory ${D}/${MY_SQLSCRIPTSDIR}/${1}"
250 fi
251
252 # warning:
253 # 314 #
254 # do NOT change the naming convention used here without changing all 315 # do NOT change the naming convention used here without changing all
255 # the other scripts that also rely upon these names 316 # the other scripts that also rely upon these names
256 317
257 # are we dealing with an 'upgrade'-type script?
258 if [ -n "${3}" ]; then 318 if [[ -n "${3}" ]]; then
259 # yes we are
260 elog "(${1}) upgrade script from ${PN}-${PVR} to ${3}" 319 elog "(${1}) upgrade script for ${PN}-${3} to ${PVR}"
261 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql" 320 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
262 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql" 321 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
263 else 322 else
264 # no, we are not
265 elog "(${1}) create script for ${PN}-${PVR}" 323 elog "(${1}) create script for ${PN}-${PVR}"
266 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql" 324 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
267 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql" 325 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
268 fi 326 fi
269} 327}
271# @FUNCTION: webapp_src_preinst 329# @FUNCTION: webapp_src_preinst
272# @DESCRIPTION: 330# @DESCRIPTION:
273# You need to call this function in src_install() BEFORE anything else has run. 331# You need to call this function in src_install() BEFORE anything else has run.
274# For now we just create required webapp-config directories. 332# For now we just create required webapp-config directories.
275webapp_src_preinst() { 333webapp_src_preinst() {
334 debug-print-function $FUNCNAME $*
335
336 # sanity checks, to catch bugs in the ebuild
337 if [[ ! -f "${T}/${SETUP_CHECK_FILE}" ]]; then
338 eerror
339 eerror "This ebuild did not call webapp_pkg_setup() at the beginning"
340 eerror "of the pkg_setup() function"
341 eerror
342 eerror "Please log a bug on http://bugs.gentoo.org"
343 eerror
344 eerror "You should use emerge -C to remove this package, as the"
345 eerror "installation is incomplete"
346 eerror
347 die "Ebuild did not call webapp_pkg_setup() - report to http://bugs.gentoo.org"
348 fi
349
350 # Hint, see the webapp_read_config() function to find where these are
351 # defined.
276 dodir "${MY_HTDOCSDIR}" 352 dodir "${MY_HTDOCSDIR}"
277 dodir "${MY_HOSTROOTDIR}" 353 dodir "${MY_HOSTROOTDIR}"
278 dodir "${MY_CGIBINDIR}" 354 dodir "${MY_CGIBINDIR}"
279 dodir "${MY_ICONSDIR}" 355 dodir "${MY_ICONSDIR}"
280 dodir "${MY_ERRORSDIR}" 356 dodir "${MY_ERRORSDIR}"
285 361
286# ============================================================================== 362# ==============================================================================
287# EXPORTED FUNCTIONS 363# EXPORTED FUNCTIONS
288# ============================================================================== 364# ==============================================================================
289 365
290# @FUNCTION: webapp_src_install
291# @DESCRIPTION:
292# This is the default src_install(). For now, we just make sure that root owns
293# everything, and that there are no setuid files.
294#
295# You need to call this function AFTER everything else has run in your custom
296# src_install().
297webapp_src_install() {
298 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
299 chmod -R u-s "${D}/"
300 chmod -R g-s "${D}/"
301
302 keepdir "${MY_PERSISTDIR}"
303 fowners "root:0" "${MY_PERSISTDIR}"
304 fperms 755 "${MY_PERSISTDIR}"
305
306 # to test whether or not the ebuild has correctly called this function
307 # we add an empty file to the filesystem
308 #
309 # we used to just set a variable in the shell script, but we can
310 # no longer rely on Portage calling both webapp_src_install() and
311 # webapp_pkg_postinst() within the same shell process
312
313 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
314}
315
316# @FUNCTION: webapp_pkg_setup 366# @FUNCTION: webapp_pkg_setup
317# @DESCRIPTION: 367# @DESCRIPTION:
318# The default pkg_setup() for this eclass. This will gather required variables 368# The default pkg_setup() for this eclass. This will gather required variables
319# from webapp-config and check if there is an application installed to 369# from webapp-config and check if there is an application installed to
320# `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set. 370# `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set.
321# 371#
322# You need to call this function BEFORE anything else has run in your custom 372# You need to call this function BEFORE anything else has run in your custom
323# pkg_setup(). 373# pkg_setup().
324webapp_pkg_setup() { 374webapp_pkg_setup() {
325 # add sanity checks here 375 debug-print-function $FUNCNAME $*
376
377 # to test whether or not the ebuild has correctly called this function
378 # we add an empty file to the filesystem
379 #
380 # we used to just set a variable in the shell script, but we can
381 # no longer rely on Portage calling both webapp_pkg_setup() and
382 # webapp_src_install() within the same shell process
383 touch "${T}/${SETUP_CHECK_FILE}"
326 384
327 # special case - some ebuilds *do* need to overwride the SLOT 385 # special case - some ebuilds *do* need to overwride the SLOT
328 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then 386 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then
329 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually" 387 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually"
330 fi 388 fi
331 389
332 # pull in the shared configuration file 390 # pull in the shared configuration file
333
334 G_HOSTNAME="localhost" 391 G_HOSTNAME="localhost"
335 webapp_read_config 392 webapp_read_config
336 393
337 # are we installing a webapp-config solution over the top of a
338 # non-webapp-config solution?
339
340 if ! use vhosts ; then
341 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}" 394 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
395
396 # if USE=vhosts is enabled OR no application is installed we're done here
397 if ! has vhosts ${IUSE} || use vhosts || [[ ! -d "${my_dir}" ]]; then
398 return
399 fi
400
342 local my_output 401 local my_output
343
344 if [ -d "${my_dir}" ] ; then
345 my_output="$(webapp_check_installedat)" 402 my_output="$(webapp_check_installedat)"
346 403
347 if [ "$?" != "0" ]; then 404 if [[ $? -ne 0 ]]; then
348 # okay, whatever is there, it isn't webapp-config-compatible 405 # okay, whatever is there, it isn't webapp-config-compatible
406 echo
407 ewarn
349 ewarn "You already have something installed in ${my_dir}" 408 ewarn "You already have something installed in ${my_dir}"
350 ewarn 409 ewarn
351 ewarn "Whatever is in ${my_dir}, it's not" 410 ewarn "Whatever is in ${my_dir}, it's not"
352 ewarn "compatible with webapp-config." 411 ewarn "compatible with webapp-config."
353 ewarn 412 ewarn
354 ewarn "This ebuild may be overwriting important files." 413 ewarn "This ebuild may be overwriting important files."
355 ewarn 414 ewarn
415 echo
416 ebeep 10
356 elif [ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]; then 417 elif [[ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]]; then
357 eerror "${my_dir} contains ${my_output}" 418 echo
358 eerror "I cannot upgrade that" 419 eerror "You already have ${my_output} installed in ${my_dir}"
420 eerror
421 eerror "I cannot upgrade a different application"
422 eerror
423 echo
359 die "Cannot upgrade contents of ${my_dir}" 424 die "Cannot upgrade contents of ${my_dir}"
360 fi
361 fi 425 fi
362 fi 426
427}
428
429# @FUNCTION: webapp_src_install
430# @DESCRIPTION:
431# This is the default src_install(). For now, we just make sure that root owns
432# everything, and that there are no setuid files.
433#
434# You need to call this function AFTER everything else has run in your custom
435# src_install().
436webapp_src_install() {
437 debug-print-function $FUNCNAME $*
438
439 # to test whether or not the ebuild has correctly called this function
440 # we add an empty file to the filesystem
441 #
442 # we used to just set a variable in the shell script, but we can
443 # no longer rely on Portage calling both webapp_src_install() and
444 # webapp_pkg_postinst() within the same shell process
445 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
446
447 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
448 chmod -R u-s "${D}/"
449 chmod -R g-s "${D}/"
450
451 keepdir "${MY_PERSISTDIR}"
452 fowners "root:0" "${MY_PERSISTDIR}"
453 fperms 755 "${MY_PERSISTDIR}"
363} 454}
364 455
365# @FUNCTION: webapp_pkg_postinst 456# @FUNCTION: webapp_pkg_postinst
366# @DESCRIPTION: 457# @DESCRIPTION:
367# The default pkg_postinst() for this eclass. This installs the web application to 458# The default pkg_postinst() for this eclass. This installs the web application to
369# display a short notice how to install this application with webapp-config. 460# display a short notice how to install this application with webapp-config.
370# 461#
371# You need to call this function AFTER everything else has run in your custom 462# You need to call this function AFTER everything else has run in your custom
372# pkg_postinst(). 463# pkg_postinst().
373webapp_pkg_postinst() { 464webapp_pkg_postinst() {
465 debug-print-function $FUNCNAME $*
466
374 webapp_read_config 467 webapp_read_config
375 468
376 # sanity checks, to catch bugs in the ebuild 469 # sanity checks, to catch bugs in the ebuild
377
378 if [ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]; then 470 if [[ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]]; then
379 eerror 471 eerror
380 eerror "This ebuild did not call webapp_src_install() at the end" 472 eerror "This ebuild did not call webapp_src_install() at the end"
381 eerror "of the src_install() function" 473 eerror "of the src_install() function"
382 eerror 474 eerror
383 eerror "Please log a bug on http://bugs.gentoo.org" 475 eerror "Please log a bug on http://bugs.gentoo.org"
386 eerror "installation is incomplete" 478 eerror "installation is incomplete"
387 eerror 479 eerror
388 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org" 480 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org"
389 fi 481 fi
390 482
391 # if 'vhosts' is not set in your USE flags, we install a copy of 483 if has vhosts ${IUSE}; then
392 # this application in ${ROOT}/var/www/localhost/htdocs/${PN}/ for you
393
394 if ! use vhosts ; then 484 if ! use vhosts; then
395 echo 485 echo
396 elog "vhosts USE flag not set - auto-installing using webapp-config" 486 elog "vhosts USE flag not set - auto-installing using webapp-config"
397 487
398 webapp_getinstalltype
399
400 G_HOSTNAME="localhost" 488 G_HOSTNAME="localhost"
401 local my_mode=-I
402 webapp_read_config 489 webapp_read_config
403 490
491 local my_mode=-I
492 webapp_getinstalltype
493
404 if [ "${IS_REPLACE}" = "1" ]; then 494 if [[ "${IS_REPLACE}" == "1" ]]; then
405 elog "${PN}-${PVR} is already installed - replacing" 495 elog "${PN}-${PVR} is already installed - replacing"
406 my_mode=-I 496 my_mode=-I
407 elif [ "${IS_UPGRADE}" = "1" ]; then 497 elif [[ "${IS_UPGRADE}" == "1" ]]; then
408 elog "${REMOVE_PKG} is already installed - upgrading" 498 elog "${REMOVE_PKG} is already installed - upgrading"
409 my_mode=-U 499 my_mode=-U
500 else
501 elog "${PN}-${PVR} is not installed - using install mode"
502 fi
503
504 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
505 elog "Running ${my_cmd}"
506 ${my_cmd}
507
508 echo
509 local cleaner="${WEBAPP_CLEANER} -p -C /${PN}"
510 einfo "Running ${cleaner}"
511 ${cleaner}
410 else 512 else
411 elog "${PN}-${PVR} is not installed - using install mode" 513 elog
514 elog "The 'vhosts' USE flag is switched ON"
515 elog "This means that Portage will not automatically run webapp-config to"
516 elog "complete the installation."
517 elog
518 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
519 elog
520 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
521 elog
522 elog "For more details, see the webapp-config(8) man page"
412 fi 523 fi
413
414 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
415 elog "Running ${my_cmd}"
416 ${my_cmd}
417
418 # run webapp-cleaner instead of emerge
419 echo
420 local cleaner="${WEBAPP_CLEANER} -p -C ${PN}"
421 einfo "Running ${cleaner}"
422 ${cleaner}
423 else 524 else
424 # vhosts flag is on
425 #
426 # let's tell the administrator what to do next
427
428 elog 525 elog
429 elog "The 'vhosts' USE flag is switched ON" 526 elog "This ebuild does not support the 'vhosts' USE flag."
430 elog "This means that Portage will not automatically run webapp-config to" 527 elog "This means that Portage will not automatically run webapp-config to"
431 elog "complete the installation." 528 elog "complete the installation."
432 elog 529 elog
433 elog "To install ${PN}-${PVR} into a virtual host, run the following command:" 530 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
434 elog 531 elog
435 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}" 532 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
436 elog 533 elog
437 elog "For more details, see the webapp-config(8) man page" 534 elog "For more details, see the webapp-config(8) man page"
438 fi 535 fi
439
440 return 0
441} 536}
442 537
443# @FUNCTION: webapp_pkg_prerm 538# @FUNCTION: webapp_pkg_prerm
444# @DESCRIPTION: 539# @DESCRIPTION:
445# This is the default pkg_prerm() for this eclass. If USE=vhosts is not set 540# This is the default pkg_prerm() for this eclass. If USE=vhosts is not set
446# remove all installed copies of this web application. Otherwise instruct the 541# remove all installed copies of this web application. Otherwise instruct the
447# user to manually remove those copies. 542# user to manually remove those copies. See bug #136959.
448webapp_pkg_prerm() { 543webapp_pkg_prerm() {
449 # remove any virtual installs that there are 544 debug-print-function $FUNCNAME $*
450 545
451 local my_output 546 local my_output=
547 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})"
548 [[ $? -ne 0 ]] && return
549
452 local x 550 local x
453 551 if has vhosts ${IUSE} && ! use vhosts; then
454 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})" 552 echo "${my_output}" | while read x; do
455 553 if [[ -f "${x}"/.webapp ]]; then
456 if [ "${?}" != "0" ]; then 554 . "${x}"/.webapp
457 return
458 fi
459
460 if ! use vhosts ; then # remove any installed copies
461
462 for x in ${my_output} ; do
463 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
464 if [ "${WEB_HOSTNAME}" -a "${WEB_INSTALLDIR}" ]; then 555 if [[ -n "${WEB_HOSTNAME}" && -n "${WEB_INSTALLDIR}" ]]; then
465 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR} 556 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR} ${PN} ${PVR}
557 fi
558 else
559 ewarn "Cannot find file ${x}/.webapp"
466 fi 560 fi
467 done 561 done
468 else # don't remove anything, but warn user. bug #136959 562 elif [[ "${my_output}" != "" ]]; then
469 563 echo
564 ewarn
470 ewarn "Don't forget to use webapp-config to remove any copies of" 565 ewarn "Don't forget to use webapp-config to remove any copies of"
471 ewarn "${PN}-${PVR} installed in" 566 ewarn "${PN}-${PVR} installed in"
472 ewarn 567 ewarn
473 568
474 for x in ${my_output} ; do 569 echo "${my_output}" | while read x; do
475 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp" 570 if [[ -f "${x}"/.webapp ]]; then
476 ewarn " ${x}" 571 ewarn " ${x}"
572 else
573 ewarn "Cannot find file ${x}/.webapp"
574 fi
477 done 575 done
576
577 ewarn
578 echo
478 fi 579 fi
479} 580}

Legend:
Removed from v.1.50  
changed lines
  Added in v.1.70

  ViewVC Help
Powered by ViewVC 1.1.20